//*****************************************************************
// 
//  JAVA Source for com.idautomation.aztec; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.aztec;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the Aztec servlet that creates a barcode from the Aztec class. */
public class IDAutomationServlet extends HttpServlet
{
    private boolean debug=false;
    public void init() throws ServletException  {  }

    // MODIFY THIS FUNCTION TO CREATE THE Aztec USING THE request PARAMETERS
    private Aztec getChart (HttpServletRequest request) 
    {
        Aztec cb=new Aztec();
        if (request!=null) 
        {
            // You may remark these parameters out if you do not need them.
            if (request.getParameter("ECL")!=null) 
            {
                int ECLVal = new Integer(request.getParameter("ECL")).intValue();
                if (ECLVal >= 1 && ECLVal <= 99)
                    cb.ecl = ECLVal;
                else
                    cb.ecl = 0;					
            }

            if (request.getParameter("NS")!=null) 
            {
                int NumOfSymbols = new Integer(request.getParameter("NS")).intValue();
                if (NumOfSymbols < 1 )
                    cb.numOfSym = 1;
                else
                    cb.numOfSym = NumOfSymbols;
            }

            if (request.getParameter("MA")!=null) cb.msgApp = request.getParameter("MA");
            if (request.getParameter("ROTATE")!=null) cb.rotate=new Integer(request.getParameter("ROTATE")).intValue();
            if (request.getParameter("LM")!=null) cb.leftMarginCM=new Double(request.getParameter("LM")).doubleValue();
            if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
            if (request.getParameter("TM")!=null) cb.topMarginCM=new Double(request.getParameter("TM")).doubleValue();
            if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
            if (request.getParameter("X")!=null) cb.X=new Double(request.getParameter("X")).doubleValue();
            if (request.getParameter("BC")!=null) cb.barColor=convertColor(request.getParameter("BC"));
            if (request.getParameter("BGC")!=null) cb.backColor=convertColor(request.getParameter("BGC"));
            if (request.getParameter("PT")!=null)
            {
                String PTParameter = request.getParameter("PT");
                if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                   PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                    cb.applyTilde = true;
                else
                    cb.applyTilde = false;
                
            }
            if (request.getParameter("RI")!=null)
            {
                String RIParameter = request.getParameter("RI");
                if(RIParameter.toUpperCase().compareTo("Y") == 0 || RIParameter.toUpperCase().compareTo("YES") == 0 ||
                   RIParameter.toUpperCase().compareTo("TRUE") == 0 || RIParameter.toUpperCase().compareTo("T") == 0)
                    cb.readerInit = true;
                else
                    cb.readerInit = false;
                
            }
            if (request.getParameter("BARCODE")!=null)
            {
                cb.code=request.getParameter("BARCODE"); 
            }
            else if(request.getParameter("D")!=null) 
            {
                cb.code=request.getParameter("D"); 
            }
            else  
            {
                cb.code="NO DATA TO ENCODE";
            }
        }
        else  
        {
            cb.code="NO DATA TO ENCODE";
        }
        return cb;
    }

    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }
    // Handle a request
    // 1. create Aztec
    // 2. draw Aztec in a Buffered Image
    // 3. encode image as GIF or JPEG and send it to the browser
    public void doGet (HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        PrintWriter	out;
        ServletOutputStream outb;
        String encode="gif";
        if (request!=null) 
        {
            if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();
            if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
            if (encode.compareTo("gif")!=0) encode="jpeg";
        }
        response.setContentType("image/"+encode);
        outb=response.getOutputStream();
        // avoid caching in browser
        response.setHeader ("Pragma", "no-cache");
        response.setHeader ("Cache-Control", "no-cache");
        response.setDateHeader ("Expires",0);
        try 
        { 
            // Create buffer
            //the default height and width if not specified.
            int w=80;
            int h=80;
            // get Aztec
            Aztec cb=getChart(request);
            if ((request!=null) && (request.getParameter("WIDTH")!=null) && (request.getParameter("HEIGHT")!=null)) 
            {
                w=new Integer(request.getParameter("WIDTH")).intValue();
                h=new Integer(request.getParameter("HEIGHT")).intValue();
            }
            else if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
            {
                cb.autoSize = false;
                w=new Integer(request.getParameter("W")).intValue();
                h=new Integer(request.getParameter("H")).intValue();
            }
            else 
            {
                //a temp image must be created to find the preferred size
                cb.autoSize=true;
                cb.setSize(90,90);
                java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
                java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
                cb.paint(imgTempGraphics);
                cb.invalidate();
                w=cb.getSize().width;
                h=cb.getSize().height;
                imgTempGraphics.dispose();
            }

            java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
            java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
            cb.setSize(w,h);
            cb.paint(BarGraphics);
            if (encode.compareToIgnoreCase("gif")==0) 
            {
                // encode buffered image to a gif
                com.idautomation.aztec.encoder.GifEncoder encoder = new com.idautomation.aztec.encoder.GifEncoder(BarImage  ,outb);
                encoder.encode();
            }
            else
            {
                // create JPEG image
                com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                //increase the JPEG quality to 100%
                com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
                param.setQuality(1.0F,true);
                encoder.setJPEGEncodeParam(param);
                encoder.encode( BarImage,param  );
            }
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }

    public void doPost (HttpServletRequest request,	HttpServletResponse response) throws ServletException
    {
        try 
        {
            doGet(request,response);
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }
}

